/*******************************************************************************
 * Copyright (c) 2010 Haifeng Li
 *   
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/

/**
 * Interpolation is the process of constructing a function that takes on
 * specified values at specified points. In engineering and science, one often
 * has a number of data points, obtained by sampling or experimentation, which
 * represent the values of a function for a limited number of values of the
 * independent variable. It is often required to interpolate (i.e. estimate)
 * the value of that function for an intermediate value of the independent
 * variable. A different problem which is closely related to interpolation is
 * the approximation of a complicated function by a simple function. 
 * 
 * @author Haifeng Li
 */
package smile.interpolation;