/*******************************************************************************
 * Copyright (c) 2010 Haifeng Li
 *   
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/

package Utils.MachineLearning.nlp.dictionary;

/**
 * Punctuation marks are symbols that indicate the structure and organization
 * of written language, as well as intonation and pauses to be observed when
 * reading aloud. In many languages, punctuation is vital to disambiguate the
 * meaning of sentences.
 * <p>
 * The rules of punctuation vary with language, location, register and time
 * and are constantly evolving. Certain aspects of punctuation are stylistic
 * and are thus the author's (or editor's) choice. Tachygraphic language forms,
 * such as those used in online chat and text messages, may have wildly
 * different rules.
 *
 * @author Haifeng Li
 */
public interface Punctuations extends Dictionary {

}
