/*
 * OpenFile.java
 *
 * Created on 8 de junio de 2023, 21:51
 */

package gui.Icons.File;

import Utils.ExampleFileFilter;
import Utils.FileManager;
import Utils.TableOptimalWidth;
import gui.KnowledgeFlow.ChooserEscritorio;
import java.io.Serializable;
import javax.swing.AbstractButton;
import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;

/**
 *
 */
public class miExampleFile extends javax.swing.JFrame implements Serializable{
    private static final long serialVersionUID = -5342289353057144755L;
    
//    private static final long serialVersionUID = 1L; 
    
    private boolean isMarketBasket;
    private String filePath = "";
    private String nameFile = "";
    private FileIcon myFileIcon;
    private FileTableModel model;
    
    /** Creates new form OpenFile */
    public miExampleFile(FileIcon icon) {
        initComponents();
        if (!filePath.equals("")) {
            tblData.setModel(new FileTableModel(filePath,','));
        }
        //radMultivalued.setSelected(true);
        isMarketBasket = false;
        myFileIcon = icon;
        model = null;
    }
    
    public void updateIcon(FileIcon icon) {
        myFileIcon = icon;
        if (!myFileIcon.filePath.equals("")) {        
            filePath = icon.filePath;
            this.model = (FileTableModel) myFileIcon.data;
            tblData.setModel(model);
            myFileIcon.getMnuLoad().setEnabled(true);
            btnexit.setEnabled(true);
        }
    }
    
    public boolean isMarketBasket() {
        return isMarketBasket;
    }
    
    public String getFilePath() {
        return filePath;
    }
    
    public void columnSizes() {
        int columns = model.getColumnCount();
        int csize = 0;
        TableColumn column = null;
        
        for (int i=0; i<columns; i++) {
            column = tblData.getColumnModel().getColumn(i);
            csize = model.getColumnName(i).length();
            column.setPreferredWidth(csize*50);
        }
    }

    public FileTableModel getModel() {
        return model;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem50 = new javax.swing.JMenuItem();
        btnAccept = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblData = new javax.swing.JTable();
        btnexit = new javax.swing.JButton();
        lblNameFile = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        Matrix = new javax.swing.JMenu();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem9 = new javax.swing.JMenuItem();
        jMenuItem10 = new javax.swing.JMenuItem();
        jMenuItem11 = new javax.swing.JMenuItem();
        jMenuItem12 = new javax.swing.JMenuItem();
        jMenuItem56 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem13 = new javax.swing.JMenuItem();
        Tensor = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem20 = new javax.swing.JMenuItem();
        jMenuItem21 = new javax.swing.JMenuItem();
        jMenuItem22 = new javax.swing.JMenuItem();
        jMenuItem29 = new javax.swing.JMenuItem();
        jMenuItem14 = new javax.swing.JMenuItem();
        jMenuItem18 = new javax.swing.JMenuItem();
        Manifold = new javax.swing.JMenu();
        jMenuItem33 = new javax.swing.JMenuItem();
        jMenuItem15 = new javax.swing.JMenuItem();
        jMenuItem36 = new javax.swing.JMenuItem();
        jMenuItem16 = new javax.swing.JMenuItem();
        jMenuItem17 = new javax.swing.JMenuItem();
        jMenuItem35 = new javax.swing.JMenuItem();
        jMenuItem19 = new javax.swing.JMenuItem();
        Projection = new javax.swing.JMenu();
        jMenuItem23 = new javax.swing.JMenuItem();
        jMenuItem24 = new javax.swing.JMenuItem();
        jMenuItem25 = new javax.swing.JMenuItem();
        jMenuItem26 = new javax.swing.JMenuItem();
        jMenuItem27 = new javax.swing.JMenuItem();
        jMenuItem28 = new javax.swing.JMenuItem();
        jMenuItem34 = new javax.swing.JMenuItem();
        jMenuItem37 = new javax.swing.JMenuItem();
        jMenuItem38 = new javax.swing.JMenuItem();
        Corrupt = new javax.swing.JMenu();
        jMenuItem30 = new javax.swing.JMenuItem();
        Kernel = new javax.swing.JMenu();
        jMenuItem48 = new javax.swing.JMenuItem();
        jMenuItem39 = new javax.swing.JMenuItem();
        jMenuItem40 = new javax.swing.JMenuItem();
        jMenuItem41 = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        jMenuItem49 = new javax.swing.JMenuItem();
        jMenuItem42 = new javax.swing.JMenuItem();
        jMenuItem43 = new javax.swing.JMenuItem();
        jMenuItem44 = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        jMenuItem51 = new javax.swing.JMenuItem();
        jMenuItem45 = new javax.swing.JMenuItem();
        jMenuItem46 = new javax.swing.JMenuItem();
        jMenuItem47 = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JPopupMenu.Separator();
        jMenuItem52 = new javax.swing.JMenuItem();
        jMenuItem53 = new javax.swing.JMenuItem();
        jMenuItem54 = new javax.swing.JMenuItem();
        jMenuItem55 = new javax.swing.JMenuItem();

        jMenuItem3.setText("cancer");

        jMenuItem50.setText("jMenuItem50");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("NetDRtool: Example File");
        setBackground(new java.awt.Color(255, 255, 255));

        btnAccept.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/play.png"))); // NOI18N
        btnAccept.setText("Play");
        btnAccept.setToolTipText("Accept and confirm this data set");
        btnAccept.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnAccept.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnAccept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAcceptActionPerformed(evt);
            }
        });

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));

        jScrollPane1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Data Table", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 12))); // NOI18N

        tblData.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblData.setToolTipText("Data preview");
        jScrollPane1.setViewportView(tblData);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1)
                .addContainerGap())
        );

        btnexit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/exit2.png"))); // NOI18N
        btnexit.setText("Exit");
        btnexit.setEnabled(false);
        btnexit.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnexit.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnexit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnexitActionPerformed(evt);
            }
        });

        lblNameFile.setText("...");

        jLabel2.setText("Name File:");

        Matrix.setText("Matrix");

        jMenuItem4.setText("Cancer");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem4);

        jMenuItem5.setText("Car");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem5);

        jMenuItem6.setText("ContactLenses");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem6);

        jMenuItem7.setText("Iris");
        jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem7ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem7);

        jMenuItem8.setText("SoyBean");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem8);

        jMenuItem9.setText("Titanic");
        jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem9ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem9);

        jMenuItem10.setText("voting");
        jMenuItem10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem10ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem10);

        jMenuItem11.setText("Weather");
        jMenuItem11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem11ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem11);

        jMenuItem12.setText("WeatherNominal");
        jMenuItem12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem12ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem12);

        jMenuItem56.setText("Icfes");
        jMenuItem56.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem56ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem56);

        jMenuItem1.setText("Arrhythmia");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem1);

        jMenuItem13.setText("Zoo");
        jMenuItem13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem13ActionPerformed(evt);
            }
        });
        Matrix.add(jMenuItem13);

        jMenuBar1.add(Matrix);

        Tensor.setText("Images");

        jMenuItem2.setText("Fashion-Mnist");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        Tensor.add(jMenuItem2);

        jMenuItem20.setText("Coil20");
        jMenuItem20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem20ActionPerformed(evt);
            }
        });
        Tensor.add(jMenuItem20);

        jMenuItem21.setText("Lego");
        jMenuItem21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem21ActionPerformed(evt);
            }
        });
        Tensor.add(jMenuItem21);

        jMenuItem22.setText("Medical-Mnist");
        jMenuItem22.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem22ActionPerformed(evt);
            }
        });
        Tensor.add(jMenuItem22);

        jMenuItem29.setText("Sign-Language");
        jMenuItem29.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem29ActionPerformed(evt);
            }
        });
        Tensor.add(jMenuItem29);

        jMenuItem14.setText("Face");
        jMenuItem14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem14ActionPerformed(evt);
            }
        });
        Tensor.add(jMenuItem14);

        jMenuItem18.setText("Mnist");
        jMenuItem18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem18ActionPerformed(evt);
            }
        });
        Tensor.add(jMenuItem18);

        jMenuBar1.add(Tensor);

        Manifold.setLabel("Manifold");

        jMenuItem33.setText("Swissroll");
        jMenuItem33.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem33ActionPerformed(evt);
            }
        });
        Manifold.add(jMenuItem33);

        jMenuItem15.setText("Swissroll20k");
        jMenuItem15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem15ActionPerformed(evt);
            }
        });
        Manifold.add(jMenuItem15);

        jMenuItem36.setText("SwissrollLabel");
        jMenuItem36.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem36ActionPerformed(evt);
            }
        });
        Manifold.add(jMenuItem36);

        jMenuItem16.setText("Sphere");
        jMenuItem16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem16ActionPerformed(evt);
            }
        });
        Manifold.add(jMenuItem16);

        jMenuItem17.setText("SphereLabel");
        jMenuItem17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem17ActionPerformed(evt);
            }
        });
        Manifold.add(jMenuItem17);

        jMenuItem35.setText("SphereRGB");
        jMenuItem35.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem35ActionPerformed(evt);
            }
        });
        Manifold.add(jMenuItem35);

        jMenuItem19.setText("Toroidal");
        jMenuItem19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem19ActionPerformed(evt);
            }
        });
        Manifold.add(jMenuItem19);

        jMenuBar1.add(Manifold);

        Projection.setLabel("Projection");

        jMenuItem23.setText("Bank05d");
        jMenuItem23.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem23ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem23);

        jMenuItem24.setText("BritishTowns");
        jMenuItem24.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem24ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem24);

        jMenuItem25.setText("Color");
        jMenuItem25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem25ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem25);

        jMenuItem26.setText("Eurodist");
        jMenuItem26.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem26ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem26);

        jMenuItem27.setText("MorseCode");
        jMenuItem27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem27ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem27);

        jMenuItem28.setText("USArrests");
        jMenuItem28.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem28ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem28);

        jMenuItem34.setText("Colombia");
        jMenuItem34.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem34ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem34);

        jMenuItem37.setText("Ingresos");
        jMenuItem37.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem37ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem37);

        jMenuItem38.setText("Producto");
        jMenuItem38.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem38ActionPerformed(evt);
            }
        });
        Projection.add(jMenuItem38);

        jMenuBar1.add(Projection);

        Corrupt.setLabel("Corrupt");

        jMenuItem30.setText("Missing");
        Corrupt.add(jMenuItem30);

        jMenuBar1.add(Corrupt);

        Kernel.setText("Kernel");

        jMenuItem48.setText("Kcoil1Label");
        jMenuItem48.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem48ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem48);

        jMenuItem39.setText("Kcoil1");
        jMenuItem39.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem39ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem39);

        jMenuItem40.setText("Kcoil2");
        jMenuItem40.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem40ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem40);

        jMenuItem41.setText("Kcoil3");
        jMenuItem41.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem41ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem41);
        Kernel.add(jSeparator1);

        jMenuItem49.setText("KSwissroll1Label");
        jMenuItem49.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem49ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem49);

        jMenuItem42.setText("KSwissroll1");
        jMenuItem42.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem42ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem42);

        jMenuItem43.setText("KSwissroll2");
        jMenuItem43.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem43ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem43);

        jMenuItem44.setText("KSwissrolll3");
        jMenuItem44.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem44ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem44);
        Kernel.add(jSeparator2);

        jMenuItem51.setText("Ksphere1Label");
        jMenuItem51.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem51ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem51);

        jMenuItem45.setText("Ksphere1");
        jMenuItem45.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem45ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem45);

        jMenuItem46.setText("Ksphere2");
        jMenuItem46.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem46ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem46);

        jMenuItem47.setText("Ksphere3");
        jMenuItem47.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem47ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem47);
        Kernel.add(jSeparator3);

        jMenuItem52.setText("Kmnist1Label");
        jMenuItem52.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem52ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem52);

        jMenuItem53.setText("Kmnist1");
        jMenuItem53.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem53ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem53);

        jMenuItem54.setText("Kmnist2");
        jMenuItem54.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem54ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem54);

        jMenuItem55.setText("Kmnist3");
        jMenuItem55.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem55ActionPerformed(evt);
            }
        });
        Kernel.add(jMenuItem55);

        jMenuBar1.add(Kernel);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnexit, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnAccept, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblNameFile)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(162, 162, 162)
                .addComponent(btnAccept)
                .addGap(70, 70, 70)
                .addComponent(btnexit)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblNameFile)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnAcceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAcceptActionPerformed
       // TODO add your handling code here:
        myFileIcon.filePath = filePath;
        myFileIcon.nameFile = nameFile;
        myFileIcon.isMarketBasket = this.isMarketBasket;
        ChooserEscritorio.setStatus("Load Example File: " + filePath);
        myFileIcon.setInfo("Load File:\n" + filePath);
        myFileIcon.getMnuLoad().setEnabled(true);
        myFileIcon.data = model;
        btnexit.setEnabled(true);
}//GEN-LAST:event_btnAcceptActionPerformed

    private void btnexitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnexitActionPerformed
        this.dispose();
    }//GEN-LAST:event_btnexitActionPerformed

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        setDataset("cancer"); 
        nameFile = "cancer";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        setDataset("car");
        nameFile = "car";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
        setDataset("contact-lenses"); 
        nameFile = "contact-lenses";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem6ActionPerformed

    private void jMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem7ActionPerformed
        setDataset("iris");
        nameFile = "iris";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem7ActionPerformed

    private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
        setDataset("soybean");
        nameFile = "soybean";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem8ActionPerformed

    private void jMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem9ActionPerformed
         setDataset("titanic");
         nameFile = "titanic";
         lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem9ActionPerformed

    private void jMenuItem10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem10ActionPerformed
        setDataset("voting");
        nameFile = "voting";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem10ActionPerformed

    private void jMenuItem11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem11ActionPerformed
         setDataset("weather");
         nameFile = "weather";
         lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem11ActionPerformed

    private void jMenuItem12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem12ActionPerformed
        setDataset("weather_nominal");
        nameFile = "weather_nominal";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem12ActionPerformed

    private void jMenuItem13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem13ActionPerformed
        setDataset("zoo");
        nameFile = "zoo";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem13ActionPerformed

    private void jMenuItem14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem14ActionPerformed
        setDataset("face");
        nameFile = "face";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem14ActionPerformed

    private void jMenuItem15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem15ActionPerformed
       setDataset("Swissroll20k");
       nameFile = "Swissroll20k";
       lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem15ActionPerformed

    private void jMenuItem24ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem24ActionPerformed
        setDataset("BritishTowns");
        nameFile = "BritishTowns";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem24ActionPerformed

    private void jMenuItem23ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem23ActionPerformed
        setDataset("bank05d");
        nameFile = "bank05d";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem23ActionPerformed

    private void jMenuItem25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem25ActionPerformed
        setDataset("colorstimuli");
        nameFile = "colorstimuli";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem25ActionPerformed

    private void jMenuItem26ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem26ActionPerformed
        setDataset("eurodist");
        nameFile = "eurodist";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem26ActionPerformed

    private void jMenuItem27ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem27ActionPerformed
        setDataset("morsecode");
        nameFile = "morsecode";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem27ActionPerformed

    private void jMenuItem28ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem28ActionPerformed
        setDataset("USArrests");
        nameFile = "USArrests";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem28ActionPerformed

    private void jMenuItem33ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem33ActionPerformed
        setDataset("swissroll"); 
        nameFile = "swissroll";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem33ActionPerformed

    private void jMenuItem16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem16ActionPerformed
        setDataset("sphere");
        nameFile = "sphere";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem16ActionPerformed

    private void jMenuItem17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem17ActionPerformed
        setDataset("spherelabel");
        nameFile = "spherelabel";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem17ActionPerformed

    private void jMenuItem19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem19ActionPerformed
        setDataset("toroide");
        nameFile = "toroide";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem19ActionPerformed

    private void jMenuItem34ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem34ActionPerformed
        setDataset("colombia");
        nameFile = "colombia";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem34ActionPerformed

    private void jMenuItem35ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem35ActionPerformed
         setDataset("sphereRGB");
         nameFile = "sphereRGB";
         lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem35ActionPerformed

    private void jMenuItem36ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem36ActionPerformed
        setDataset("SwissrollLabel");
        nameFile = "SwissrollLabel";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem36ActionPerformed

    private void jMenuItem37ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem37ActionPerformed
         setDataset("ingreso");
         nameFile = "ingreso";
         lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem37ActionPerformed

    private void jMenuItem38ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem38ActionPerformed
         setDataset("producto");
         nameFile = "producto";
         lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem38ActionPerformed

    private void jMenuItem39ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem39ActionPerformed
        setDataset("Kcoil1");
        nameFile = "Kcoil1";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem39ActionPerformed

    private void jMenuItem40ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem40ActionPerformed
        setDataset("Kcoil2");
        nameFile = "Kcoil2";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem40ActionPerformed

    private void jMenuItem41ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem41ActionPerformed
        setDataset("Kcoil3");
        nameFile = "Kcoil3";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem41ActionPerformed

    private void jMenuItem42ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem42ActionPerformed
        setDataset("Kroll1");
        nameFile = "Kroll1";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem42ActionPerformed

    private void jMenuItem43ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem43ActionPerformed
        setDataset("Kroll2");
        nameFile = "Kroll2";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem43ActionPerformed

    private void jMenuItem44ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem44ActionPerformed
        setDataset("Kroll3");
        nameFile = "Kroll3";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem44ActionPerformed

    private void jMenuItem45ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem45ActionPerformed
        setDataset("Ksphere1");
        nameFile = "Ksphere1";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem45ActionPerformed

    private void jMenuItem46ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem46ActionPerformed
        setDataset("Ksphere2");
        nameFile = "Ksphere2";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem46ActionPerformed

    private void jMenuItem47ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem47ActionPerformed
        setDataset("Ksphere3");
        nameFile = "Ksphere3";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem47ActionPerformed

    private void jMenuItem48ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem48ActionPerformed
        setDataset("Kcoil1Labels");
        nameFile = "Kcoil1Labels";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem48ActionPerformed

    private void jMenuItem49ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem49ActionPerformed
        setDataset("Kroll1Labels");
        nameFile = "Kroll1Labels";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem49ActionPerformed

    private void jMenuItem51ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem51ActionPerformed
        setDataset("Ksphere1Labels");
        nameFile = "Ksphere1Labels";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem51ActionPerformed

    private void jMenuItem52ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem52ActionPerformed
        setDataset("Km1Labels");
        nameFile = "Km1Labels";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem52ActionPerformed

    private void jMenuItem53ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem53ActionPerformed
        setDataset("Km1");
        nameFile = "Km1";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem53ActionPerformed

    private void jMenuItem54ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem54ActionPerformed
        setDataset("Km2");
        nameFile = "Km2";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem54ActionPerformed

    private void jMenuItem55ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem55ActionPerformed
        setDataset("Km3");
        nameFile = "Km3";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem55ActionPerformed

    private void jMenuItem56ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem56ActionPerformed
        setDataset("icfes");
        nameFile = "icfes";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem56ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        setDataset("arritmia");
        nameFile = "arritmia";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        setDataset("fashion");
        nameFile = "fashion";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jMenuItem20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem20ActionPerformed
        setDataset("Coil20");
        nameFile = "Coil20";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem20ActionPerformed

    private void jMenuItem21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem21ActionPerformed
        setDataset("Lego");
        nameFile = "Lego";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem21ActionPerformed

    private void jMenuItem22ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem22ActionPerformed
        setDataset("Medicalmnist");
        nameFile = "MedicalMnist";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem22ActionPerformed

    private void jMenuItem29ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem29ActionPerformed
        setDataset("Signlanguage");
        nameFile = "Signlanguage";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem29ActionPerformed

    private void jMenuItem18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem18ActionPerformed
        setDataset("Mnist");
        nameFile = "Mnist";
        lblNameFile.setText(nameFile);
    }//GEN-LAST:event_jMenuItem18ActionPerformed

    public FileTableModel getTableModel(){
        return model;
    } 
    
   public void setDataset(String db){
       
       switch (db) {
            case "adults":
            filePath = "src/datasets/association/adults.csv";  
            break;

            case "autos":
            filePath = "src/datasets/association/autos.csv";  
            break;
            
            case "cancer":
            filePath = "src/datasets/classification/cancer.csv";  
            break;

            case "car":
            filePath = "src/datasets/classification/car.csv";  
            break;
            
            case "contact-lenses":
            filePath = "src/datasets/classification/contact-lenses.csv";  
            break;
            
            case "iris":
            filePath = "src/datasets/classification/iris.csv";  
            break;
            
            case "soybean":
            filePath = "src/datasets/classification/soybean.csv";  
            break;
            
            case "titanic":
            filePath = "src/datasets/classification/titanic.csv";  
            break;
            
            case "voting":
            filePath = "src/datasets/classification/voting.csv";  
            break;
            
            case "weather":
            filePath = "src/datasets/classification/weather.csv";  
            break;
            
            case "weather_nominal":
            filePath = "src/datasets/classification/weather_nominal.csv";  
            break;
            
            case "icfes":
            filePath = "src/datasets/classification/icfes.csv";  
            break;
            
            case "zoo":
            filePath = "src/datasets/cluster/zoo.csv";  
            break;
            
            case "face":
            filePath = "src/datasets/manifold/face.csv";  
            break;
            
            case "Swissroll20k":
            filePath = "src/datasets/manifold/swissroll20k.csv";  
            break;  
            
            case "SwissrollLabel":
            filePath = "src/datasets/manifold/SwissrollLabel.csv";  
            break; 

            case "test":
            filePath = "src/datasets/prediction/airline/test.csv";  
            break;  
            
            case "train-0.1m":
            filePath = "src/datasets/prediction/airline/train-0.1m.csv";  
            break;  
            
            case "train-1m":
            filePath = "src/datasets/prediction/airline/train-1m.csv";  
            break;  
            
            case "segment-challenge":
            filePath = "src/datasets/prediction/segment/segment-challenge.csv";  
            break;  
            
            case "segment-test":
            filePath = "src/datasets/prediction/segment/segment-test.csv";  
            break;
            
            case "bank05d":
            filePath = "src/datasets/projection/bank05d.csv";  
            break;
            
            case "BritishTowns":
            filePath = "src/datasets/projection/BritishTowns.csv";  
            break;
            
            case "colorstimuli":
            filePath = "src/datasets/projection/colorstimuli.csv";  
            break;
            
            case "eurodist":
            filePath = "src/datasets/projection/eurodist.csv";  
            break;
            
            case "morsecode":
            filePath = "src/datasets/projection/morsecode.csv";  
            break;
            
            case "USArrests":
            filePath = "src/datasets/projection/USArrests.csv";  
            break;
            
            case "ingreso":
            filePath = "src/datasets/projection/ingreso.csv";  
            break;
            
            case "gdp":
            filePath = "src/datasets/regresion/gdp.csv";  
            break;
            
            case "swissroll":
            filePath = "src/datasets/manifold/swissRoll.csv"; 
            break;
            
            case "sphere":
            filePath = "src/datasets/manifold/sphere.csv"; 
            break;
            
            case "spherelabel":
            filePath = "src/datasets/manifold/SphereLabel.csv"; 
            break;
            
            case "sphereRGB":
            filePath = "src/datasets/manifold/sphereRGB.csv"; 
            break;
            
            case "toroide":
            filePath = "src/datasets/manifold/toroide.csv"; 
            break;
            
            case "colombia":
            filePath = "src/datasets/projection/colombia.csv"; 
            break;
            
            case "producto":
            filePath = "src/datasets/projection/producto.csv"; 
            break;   
             
            case "Kcoil1Labels":
            filePath = "src/datasets/kernel/Kcoil1Labels.csv"; 
            break; 
            
            case "Kcoil1":
            filePath = "src/datasets/kernel/Kcoil1.csv"; 
            break; 
            
            case "Kcoil2":
            filePath = "src/datasets/kernel/Kcoil2.csv"; 
            break; 
            
            case "Kcoil3":
            filePath = "src/datasets/kernel/Kcoil3.csv"; 
            break; 
            
            case "Kroll1Labels":
            filePath = "src/datasets/kernel/Kroll1Labels.csv"; 
            break; 
            
            case "Kroll1":
            filePath = "src/datasets/kernel/Kroll1.csv"; 
            break; 
            
            case "Kroll2":
            filePath = "src/datasets/kernel/Kroll2.csv"; 
            break; 
            
            case "Kroll3":
            filePath = "src/datasets/kernel/Kroll3.csv"; 
            break; 
            
            case "Ksphere1Labels":
            filePath = "src/datasets/kernel/Ksphere1Labels.csv"; 
            break; 
            
            case "Ksphere1":
            filePath = "src/datasets/kernel/Ksphere1.csv"; 
            break; 
            
            case "Ksphere2":
            filePath = "src/datasets/kernel/Ksphere2.csv"; 
            break; 
            
            case "Ksphere3":
            filePath = "src/datasets/kernel/Ksphere3.csv"; 
            break; 
            
            case "Km1Labels":
            filePath = "src/datasets/kernel/Km1Labels.csv"; 
            break; 
            
            case "Km1":
            filePath = "src/datasets/kernel/Km1.csv"; 
            break; 
            
            case "Km2":
            filePath = "src/datasets/kernel/Km2.csv"; 
            break; 
            
            case "Km3":
            filePath = "src/datasets/kernel/Km3.csv"; 
            break; 
            
            case "arritmia":
            filePath = "src/datasets/classification/arritmia.csv";  
            break;
            
            case "fashion":
            filePath = "src/datasets/tensors/FashionMnist.csv";  
            break;
            
            case "Coil20":
            filePath = "src/datasets/tensors/Coil20.csv";  
            break;
            
            case "Lego":
            filePath = "src/datasets/tensors/Lego.csv";  
            break;
            
            case "Medicalmnist":
            filePath = "src/datasets/tensors/medicalMnist.csv";  
            break;
            
            case "Signlanguage":
            filePath = "src/datasets/tensors/signLanguage.csv";  
            break;
            
            case "Mnist":
            filePath = "src/datasets/tensors/Mnist.csv";  
            break;

            // DEFAULT
            default:
            filePath = "src/datasets/classification/iris.csv";  
            break;
        }
  
        model = new FileTableModel(filePath,".csv",',');
        tblData.setModel(model);
        TableOptimalWidth.setOptimalColumnWidth(tblData, 10);
   }
   
//    /**
//     * @param args the command line arguments
//     */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            
//            public void run() {
////                new miOpenFile(fi).setVisible(true);
//            }
//        });
//    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu Corrupt;
    private javax.swing.JMenu Kernel;
    private javax.swing.JMenu Manifold;
    private javax.swing.JMenu Matrix;
    private javax.swing.JMenu Projection;
    private javax.swing.JMenu Tensor;
    private javax.swing.JButton btnAccept;
    private javax.swing.JButton btnexit;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem10;
    private javax.swing.JMenuItem jMenuItem11;
    private javax.swing.JMenuItem jMenuItem12;
    private javax.swing.JMenuItem jMenuItem13;
    private javax.swing.JMenuItem jMenuItem14;
    private javax.swing.JMenuItem jMenuItem15;
    private javax.swing.JMenuItem jMenuItem16;
    private javax.swing.JMenuItem jMenuItem17;
    private javax.swing.JMenuItem jMenuItem18;
    private javax.swing.JMenuItem jMenuItem19;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem20;
    private javax.swing.JMenuItem jMenuItem21;
    private javax.swing.JMenuItem jMenuItem22;
    private javax.swing.JMenuItem jMenuItem23;
    private javax.swing.JMenuItem jMenuItem24;
    private javax.swing.JMenuItem jMenuItem25;
    private javax.swing.JMenuItem jMenuItem26;
    private javax.swing.JMenuItem jMenuItem27;
    private javax.swing.JMenuItem jMenuItem28;
    private javax.swing.JMenuItem jMenuItem29;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem30;
    private javax.swing.JMenuItem jMenuItem33;
    private javax.swing.JMenuItem jMenuItem34;
    private javax.swing.JMenuItem jMenuItem35;
    private javax.swing.JMenuItem jMenuItem36;
    private javax.swing.JMenuItem jMenuItem37;
    private javax.swing.JMenuItem jMenuItem38;
    private javax.swing.JMenuItem jMenuItem39;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem40;
    private javax.swing.JMenuItem jMenuItem41;
    private javax.swing.JMenuItem jMenuItem42;
    private javax.swing.JMenuItem jMenuItem43;
    private javax.swing.JMenuItem jMenuItem44;
    private javax.swing.JMenuItem jMenuItem45;
    private javax.swing.JMenuItem jMenuItem46;
    private javax.swing.JMenuItem jMenuItem47;
    private javax.swing.JMenuItem jMenuItem48;
    private javax.swing.JMenuItem jMenuItem49;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem50;
    private javax.swing.JMenuItem jMenuItem51;
    private javax.swing.JMenuItem jMenuItem52;
    private javax.swing.JMenuItem jMenuItem53;
    private javax.swing.JMenuItem jMenuItem54;
    private javax.swing.JMenuItem jMenuItem55;
    private javax.swing.JMenuItem jMenuItem56;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator3;
    private javax.swing.JLabel lblNameFile;
    private javax.swing.JTable tblData;
    // End of variables declaration//GEN-END:variables
}
