/*
 * OpenFile.java
 *
 * Created on 8 de junio de 2023, 21:51
 * Juan Carlos Alvarado
 */

package gui.Icons.File;

import Utils.ExampleFileFilter;
import Utils.FileManager;
import Utils.TableOptimalWidth;
import gui.KnowledgeFlow.ChooserEscritorio;
import java.io.Serializable;
import javax.swing.AbstractButton;
import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;


import processing.core.*; 
import processing.data.*; 

/**
 *
 */
public class miOpenFile extends javax.swing.JFrame implements Serializable{
    private static final long serialVersionUID = -5342289353057144755L;
    
//    private static final long serialVersionUID = 1L; 
    
    private boolean isMarketBasket;
    private String filePath = "";
    private String nameFile = "";
    private FileIcon myFileIcon;
    private FileTableModel model;
    
    /** Creates new form OpenFile */
    public miOpenFile(FileIcon icon) {
        initComponents();
        if (!filePath.equals("")) {
            tblData.setModel(new FileTableModel(filePath,','));
        }
        //radMultivalued.setSelected(true);
        isMarketBasket = false;
        myFileIcon = icon;
        model = null;
    }
    
    public void updateIcon(FileIcon icon) {
        myFileIcon = icon;
        if (!myFileIcon.filePath.equals("")) {        
            filePath = icon.filePath;
            txtFile.setText(filePath);
            this.model = (FileTableModel) myFileIcon.data;
            tblData.setModel(model);
            myFileIcon.getMnuLoad().setEnabled(true);
            btnexit.setEnabled(true);
        }
    }
    
    public boolean isMarketBasket() {
        return isMarketBasket;
    }
    
    public String getFilePath() {
        return filePath;
    }
    
    public void columnSizes() {
        int columns = model.getColumnCount();
        int csize = 0;
        TableColumn column = null;
        
        for (int i=0; i<columns; i++) {
            column = tblData.getColumnModel().getColumn(i);
            csize = model.getColumnName(i).length();
            column.setPreferredWidth(csize*50);
        }
    }

    public FileTableModel getModel() {
        return model;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        openFile = new javax.swing.JFileChooser();
        buttonGroup1 = new javax.swing.ButtonGroup();
        btnAccept = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblData = new javax.swing.JTable();
        lblFile = new javax.swing.JLabel();
        txtFile = new javax.swing.JTextField();
        btnBrowse = new javax.swing.JButton();
        btnexit = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        rdoComa = new javax.swing.JRadioButton();
        rdoPuntoComa = new javax.swing.JRadioButton();

        openFile.setCurrentDirectory(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("NetDRtool: Open File");
        setBackground(new java.awt.Color(255, 255, 255));

        btnAccept.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/play.png"))); // NOI18N
        btnAccept.setText("Play");
        btnAccept.setToolTipText("Accept and confirm this data set");
        btnAccept.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnAccept.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnAccept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAcceptActionPerformed(evt);
            }
        });

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));

        jScrollPane1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Data Table", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 12))); // NOI18N

        tblData.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblData.setToolTipText("Data preview");
        jScrollPane1.setViewportView(tblData);

        lblFile.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        lblFile.setText("Data File");

        txtFile.setEditable(false);
        txtFile.setToolTipText("File path");
        txtFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtFileActionPerformed(evt);
            }
        });

        btnBrowse.setForeground(new java.awt.Color(51, 51, 51));
        btnBrowse.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/views-24.png"))); // NOI18N
        btnBrowse.setText("Browse");
        btnBrowse.setToolTipText("Browse a file");
        btnBrowse.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnBrowse.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnBrowse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBrowseActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(lblFile)
                                .addGap(376, 376, 376))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(txtFile)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                        .addComponent(btnBrowse)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(lblFile)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtFile, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(btnBrowse))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 347, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(58, Short.MAX_VALUE))
        );

        btnexit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/exit2.png"))); // NOI18N
        btnexit.setText("Exit");
        btnexit.setEnabled(false);
        btnexit.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnexit.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnexit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnexitActionPerformed(evt);
            }
        });

        jLabel1.setText("Delimiter:");

        buttonGroup1.add(rdoComa);
        rdoComa.setSelected(true);
        rdoComa.setText(",");

        buttonGroup1.add(rdoPuntoComa);
        rdoPuntoComa.setText(";");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(rdoPuntoComa)
                    .addComponent(rdoComa)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(btnexit, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnAccept, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addGap(48, 48, 48)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rdoComa)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rdoPuntoComa)
                .addGap(71, 71, 71)
                .addComponent(btnAccept)
                .addGap(80, 80, 80)
                .addComponent(btnexit)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnBrowseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBrowseActionPerformed
        // TODO add your handling code here:
        ExampleFileFilter filter = new ExampleFileFilter();
        filter.addExtension("arff");
        filter.addExtension("csv");
        filter.setDescription("Data Files");
        openFile.setFileFilter(filter);
        int sel = openFile.showOpenDialog(this);
        if(sel == openFile.APPROVE_OPTION) {
            String file = openFile.getSelectedFile().getAbsolutePath();
            
            // obtengo el nombre del archivo quitando la ruta
            String[] arrayFile = file.split("\\\\");
            nameFile = arrayFile[arrayFile.length-1];
            nameFile = nameFile.replaceAll(".csv", "");
            
            String ext = filter.getExtension(openFile.getSelectedFile());
            txtFile.setText(file);
            filePath = file;
            // pasar la extension a FileTableModel
            char delimiter = ',';
            if(rdoComa.isSelected())
               delimiter = ',';
            else if(rdoPuntoComa.isSelected())
               delimiter = ';';
                    
            model = new FileTableModel(file,ext,delimiter);
            tblData.setModel(model);
            TableOptimalWidth.setOptimalColumnWidth(tblData, 10);
            //columnSizes();
        }
}//GEN-LAST:event_btnBrowseActionPerformed

    private void btnAcceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAcceptActionPerformed
       // TODO add your handling code here:
        myFileIcon.filePath = filePath;
        myFileIcon.nameFile = nameFile;

        myFileIcon.isMarketBasket = this.isMarketBasket;
        ChooserEscritorio.setStatus("Load File: " + filePath);
        myFileIcon.setInfo("Load File:\n" + filePath);
        myFileIcon.getMnuLoad().setEnabled(true);
        myFileIcon.data = model;
        btnexit.setEnabled(true);
}//GEN-LAST:event_btnAcceptActionPerformed

    private void txtFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtFileActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtFileActionPerformed

    private void btnexitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnexitActionPerformed
        this.dispose();
    }//GEN-LAST:event_btnexitActionPerformed

    public FileTableModel getTableModel(){
        return model;
    } 
    
   
//    /**
//     * @param args the command line arguments
//     */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            
//            public void run() {
////                new miOpenFile(fi).setVisible(true);
//            }
//        });
//    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAccept;
    private javax.swing.JButton btnBrowse;
    private javax.swing.JButton btnexit;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblFile;
    private javax.swing.JFileChooser openFile;
    private javax.swing.JRadioButton rdoComa;
    private javax.swing.JRadioButton rdoPuntoComa;
    private javax.swing.JTable tblData;
    private javax.swing.JTextField txtFile;
    // End of variables declaration//GEN-END:variables
}
