/*
 * showRules.java
 *
 */

package gui.Icons.Rules;

import Utils.AssocRules;
import Utils.ExampleFileFilter;
import Utils.FileManager;
import Utils.TableOptimalWidth;
import gui.KnowledgeFlow.ChooserEscritorio;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JTable;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;

/**
 *
 * @author  Proyecto Taryi
 */
public class showRules extends javax.swing.JFrame {
    /** Las reglas de asociaciÃ³n. */
    private AssocRules rules;
    
    /** Tabla analizada. */
    private String table;
    
    /** Soporte minimo del sistema. */
    private String support;
    
    /** Confianza. */
    private String confidence;
    
    /** Creates new form ShowRules */
    public showRules(AssocRules rules, String table, String support, String confidence) {
        this.rules = rules;
        this.table = table;
        this.support = support;
        this.confidence = confidence;
        
        initComponents();
        
        if(rules.getRules().size() != 0) {
            RulesTableModel model = new RulesTableModel(rules.getRules());
            tblRules.setModel(model);
            tblRules.setAutoResizeMode(tblRules.AUTO_RESIZE_OFF);
            TableOptimalWidth.setOptimalColumnWidth(tblRules);
            ChooserEscritorio.setStatus("Generate " + tblRules.getRowCount() + " rules with confidence "
                    + confidence + "%");
        } else {
            // No hay resultados //
        }
        
        lblTable.setText(table);
        lblSupport.setText(support + "%");
        lblConfidence.setText(confidence + "%");
        
        this.addJTableHeaderListener();
    }
    
    public void addJTableHeaderListener() {
        MouseAdapter mouseListener = new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                TableColumnModel columnModel = tblRules.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX());
                //System.out.println("column model " + viewColumn);
                int column = tblRules.convertColumnIndexToModel(viewColumn);
                System.out.println("column " + column);
                // Ordenar elementos de la columna de la tabla.
                if(e.getClickCount() == 1 && column != -1) {
                    // Ordenar por confianza.
                    if(column == 1) {
                        rules.sortByGoldStone(0);
                        rules.sortByGoldStone(1);
                        tblRules.updateUI();
                    } else if(column == 2) {
                        rules.sortByConfidence();
                        tblRules.updateUI();
                    }
                }
            }
        };
        JTableHeader header = tblRules.getTableHeader();
        header.addMouseListener(mouseListener);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        Save = new javax.swing.JFileChooser();
        jLabel1 = new javax.swing.JLabel();
        lblTable = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        lblSupport = new javax.swing.JLabel();
        lblConfidence = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        btnSave = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblRules = new javax.swing.JTable();

        Save.setCurrentDirectory(new java.io.File("C:\\home\\ivan\\tariy\\Reportes"));

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                formMousePressed(evt);
            }
        });

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/stock_text_justify.png"))); // NOI18N
        jLabel1.setText("Analized Table:");

        lblTable.setToolTipText("The table that has been analyzed");
        lblTable.setBorder(new javax.swing.border.LineBorder(javax.swing.UIManager.getDefaults().getColor("Button.focus"), 1, true));

        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/text_strike.png"))); // NOI18N
        jLabel2.setText("System Support:");

        lblSupport.setToolTipText("Support used");
        lblSupport.setBorder(new javax.swing.border.LineBorder(javax.swing.UIManager.getDefaults().getColor("Button.focus"), 1, true));

        lblConfidence.setToolTipText("Confidence used");
        lblConfidence.setBorder(new javax.swing.border.LineBorder(javax.swing.UIManager.getDefaults().getColor("Button.focus"), 1, true));

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/rules.png"))); // NOI18N
        jLabel3.setText("Confidence:");

        btnSave.setForeground(new java.awt.Color(51, 51, 51));
        btnSave.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/save_all.png"))); // NOI18N
        btnSave.setText("Save Report");
        btnSave.setToolTipText("Save this report");
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });

        jScrollPane1.setBorder(javax.swing.BorderFactory.createTitledBorder("Rules set"));
        jScrollPane1.setToolTipText("Set of rules that pass the given support and confidence");

        tblRules.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        jScrollPane1.setViewportView(tblRules);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(576, 576, 576)
                        .add(btnSave, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 143, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(21, 21, 21)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 698, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(layout.createSequentialGroup()
                                        .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 123, Short.MAX_VALUE)
                                        .add(10, 10, 10))
                                    .add(layout.createSequentialGroup()
                                        .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                                    .add(layout.createSequentialGroup()
                                        .add(29, 29, 29)
                                        .add(jLabel3)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 10, Short.MAX_VALUE)))
                                .add(1, 1, 1)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(lblTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 564, Short.MAX_VALUE)
                                    .add(lblSupport, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 564, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(lblConfidence, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 564, Short.MAX_VALUE)))))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(lblTable, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(14, 14, 14)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(lblSupport, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(15, 15, 15)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(lblConfidence, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(33, 33, 33)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 327, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnSave)
                .addContainerGap())
        );

        layout.linkSize(new java.awt.Component[] {lblConfidence, lblSupport, lblTable}, org.jdesktop.layout.GroupLayout.VERTICAL);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void formMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMousePressed
        
    }//GEN-LAST:event_formMousePressed
    
    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        
    }//GEN-LAST:event_formMouseClicked
    
    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
// TODO add your handling code here:
        ExampleFileFilter ext = new ExampleFileFilter(".tux", "Archivo de reglas");
        String path;
        FileManager fm;
        
        Save.addChoosableFileFilter(ext);
        int saveOK = Save.showSaveDialog(this);
        if(saveOK == Save.APPROVE_OPTION) {
            path = Save.getSelectedFile().getAbsolutePath();
            path += ".tux";
            fm = new FileManager(path);
            fm.writeString("ASSOCIATION RULES\n\nMined with: " + table + "\n" +
                    "Support: " + support + "%\n" + "Confidence: " + confidence +
                    "%\n\n" + rules.toString());
        }
    }//GEN-LAST:event_btnSaveActionPerformed
        
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                //new showRules().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JFileChooser Save;
    private javax.swing.JButton btnSave;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblConfidence;
    private javax.swing.JLabel lblSupport;
    private javax.swing.JLabel lblTable;
    private javax.swing.JTable tblRules;
    // End of variables declaration//GEN-END:variables
    
}
