/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * miContenedor.java
 *
 * Created on 24-ene-2024, 14:32:54
 */
package gui.KnowledgeFlow;

import Utils.SocketServer;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;

/**
 *
 * @author Juan Carlos
 */
public class miContenedor extends javax.swing.JPanel {
    
    /** Selector panel to Connection */
    mipnlPreprocesamiento pre;
    /** Selector panel to Algorithm */
    mipnlAlgoritmos alg;
    /** Selector panel to Viewer */
    mipnlVisores vis;
    /** Selector panel to Pre-processing */
    mipnlFilters fil;
    /** Selector panel to DR*/
    mipnlDR dr;
    mipnlEvaluation eva;
    /** Work area class */        
    MyCanvas canvas;
    // used for save the JLabel selected
    private JLabel dragged;
    // used in the hide left component in the JSplitPanne Contenedor
    private int backup_select;
    
    private SocketServer mySocket;

    /** Creates new form miContenedor */
    public miContenedor() {
        initComponents();
        
        mySocket = new SocketServer();
        
        canvas = new MyCanvas(this);
        
        pre = new mipnlPreprocesamiento(this);
        dr = new mipnlDR(this);
        alg = new mipnlAlgoritmos(this);
        vis = new mipnlVisores(this);
        fil = new mipnlFilters(this);
        eva = new mipnlEvaluation(this);
        
        scrollPanel.setViewportView(canvas);
        scrollSelector.setViewportView(pre);
        contenedor.setLeftComponent(scrollSelector);
        contenedor.setRightComponent(scrollPanel);
        
        contenedor.setTopComponent(scrollSelector);
        contenedor.setBottomComponent(scrollPanel);
    }
    
    /**
     * Return the JLabel associated to icon selected.
     */
    public JLabel getDragged() {
        return dragged;
    }
    
    /**
     * Set the JLabel which was selected.
     *
     * @param dragged JLabel selected.
     */
    public void setDragged(JLabel dragged) {
        this.dragged = dragged;
    }
    
    /**
     * Get the Container
     */
    public JSplitPane getContenedor(){
        return contenedor;
    }
    
    public SocketServer getSocket(){
        return mySocket;
    }
    
    /**
     * Change or hide the left panel
     *
     * @param select The selector panel
     */
    public void changeDividerLocation(int divLoc){
       contenedor.setDividerLocation(divLoc);
    }
    
    public void changeLeftPanel(int select){
        JPanel selector = null;
        switch(select){
            case 0:
                if(backup_select == select){
                    backup_select = -1;
                } else {
                    selector = pre;
                    backup_select = select;
                }
                break;
            case 1:
                if(backup_select == select){
                    backup_select = -1;
                } else {
                    selector = fil;
                    backup_select = select;
                }
                break;
            case 2:
                if(backup_select == select){
                    backup_select = -1;
                } else {
                    selector = dr;
                    backup_select = select;
                }
                break;
            case 3:
                if(backup_select == select){
                    backup_select = -1;
                } else {
                    selector = vis;
                    backup_select = select;
                }
                break;
            case 4:
                if(backup_select == select){
                    backup_select = -1;
                } else {
                    selector = eva;
                    backup_select = select;
                }
                break;
        }
        if(selector == null){
            contenedor.setDividerLocation(0);
        } else {
            contenedor.setDividerLocation(120);
        }
        scrollSelector.setViewportView(selector);
    }
    /**
     * Get the JScrollPane associated to Work Area.
     */
    public JScrollPane getScrollPanel() {
        return scrollPanel;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        contenedor = new javax.swing.JSplitPane();
        scrollPanel = new javax.swing.JScrollPane();
        scrollSelector = new javax.swing.JScrollPane();

        contenedor.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        contenedor.setDividerLocation(100);
        contenedor.setDividerSize(2);
        contenedor.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        scrollPanel.setBackground(new java.awt.Color(255, 255, 255));
        scrollPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Drag and Drop", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 0, 12))); // NOI18N
        contenedor.setRightComponent(scrollPanel);
        contenedor.setLeftComponent(scrollSelector);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(contenedor, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(contenedor, javax.swing.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JSplitPane contenedor;
    private javax.swing.JScrollPane scrollPanel;
    private javax.swing.JScrollPane scrollSelector;
    // End of variables declaration//GEN-END:variables
}
